#include "jserver.h"

#define SEXY_NEW 0 /* sent to svc_mux when a new client connects */
#define SEXY_SET 1
#define SEXY_READ 2
#define SEXY_WRITE 3
#define SEXY_ERROR 4
#define SEXY_CLOSE 5

typedef struct sexy_struct
{
    int type;
    int size;
    int fd;
    void *xs;
} *sexy_t, _sexy_t;

/* mux thread wrapper */
typedef struct mux_struct
{
    thread t;
    int in, out, conns, buffsz, cur;
    void *buff;
} *mux_t, _mux_t;

void mux_write(int type, thread from, char *data, int datasz);
void mux_close(thread t);

void mux_read(thread t, void *data, int bufsz); /* callback for tstream the mux is on */
void mux_packet(mux_t mux, sexy_t s, char *data, int size); /* handles new packets */
void mux_client_filter(thread t, xmlnode in, int type);

void mux_stream(thread t, void *buffer, int bufsz);
thread mux_stream_new(mux_t mux, int fd, xmlstream_onNode evt);
int mux_stream_write(thread t, xmlnode x);
xmlnode mux_stream_header(char *namespace, char *to, char *from);
void mux_stream_write_header(thread t, xmlnode x);
void mux_stream_close(thread t);
void mux_stream_error(thread t, char *err);
