#include "mux.h"

/* in here we create sexy packets and write them to the mux tstream */

void mux_write(int type, thread from, char *data, int datasz)
{
    pool p;
    sexy_t s;
    tstream_buffer b;
    tstream ts = (tstream)(from->data);
    mux_t mux = (mux_t)(ts->data5);

    if(mux->t == NULL)
    {
        log_debug(ZONE,"writing to an invalid mux %X",mux);
        return;
    }

    mux->out++;

    log_debug(ZONE,"mux %X/%d type %d fd %d size %d",mux,mux->out,type,ts->fd,datasz);

    /* create the sexy struct */
    p = pool_new();
    s = pmalloc(p,sizeof(_sexy_t));
    s->fd = ts->fd;
    s->type = type;
    s->xs = (void *)from;
    s->size = datasz;

    /* write it into a buffer */
    b = pmalloc(p,sizeof(struct tstream_buffer_struct));
    b->data = (char *)s;
    b->data_sz = sizeof(_sexy_t);
    b->sent = 0;
    b->obj = b->next = NULL;
    b->p = p;
    tstream_write_buffer(mux->t, b);

    if(datasz == 0)
        return;

    /* write data after it */
    p = pool_new();
    b = pmalloc(p,sizeof(struct tstream_buffer_struct));
    b->data = pmalloc(p,datasz);
    memcpy(b->data,data,datasz);
    b->data_sz = datasz;
    b->sent = 0;
    b->obj = b->next = NULL;
    b->p = p;
    tstream_write_buffer(mux->t, b);

}

/* ask the thread to close */
void mux_close(thread t)
{
    mux_write(SEXY_CLOSE,t,NULL,0);
}
