#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <signal.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/stat.h>
#include <sys/uio.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/un.h>

/* How do I do this correctly? */
#ifndef __USE_XOPEN
#define __USE_XOPEN
#endif

#include <sys/select.h>
#include <poll.h>
#include <strings.h>
#include <sys/ioctl.h>

#include <libxode.h>

/* typedef socklen_t socklen_t; */

#define TRUE 1
#define MY_OPEN_MAX 1024
#define LISTENQ 1000
#define MAXLINE 1000
#define INFTIM (-1)
#define SERV_PORT 5222
#define SA struct sockaddr

typedef struct stream_buffer_struct
{
    char *data;
    int data_sz;
    int sent;
    struct stream_buffer_struct *next;
    pool p;
} *stream_buffer, _stream_buffer;

typedef struct stream_struct
{
    int fd;
    stream_buffer write;
    void *xmlstream;
    struct stream_struct *next;
    int buffsz, cur;
    void *buff;
} *stream, _stream;

#define SEXY_NEW 0
#define SEXY_SET 1
#define SEXY_READ 2
#define SEXY_WRITE 3
#define SEXY_ERROR 4
#define SEXY_CLOSE 5

typedef struct sexy_struct
{
    int type;
    int size;
    int fd;
    void *data;
} *sexy_t, _sexy_t;

void stream_write(stream cur, void *buffer, int bufsz);
void stream_read(int masterfd, stream mux, void *data, int buffsz);
stream stream_new(int fd);
void stream_unlink(int fd);
stream stream_find_by_fd(int fd);
void stream_reset(void);

size_t readline(int fd, void *vptr, size_t maxlen);
size_t writen(int fd, const void *vptr, size_t n);
size_t readn(int fd, void *vptr, size_t n);

int make_masterfd(char *host, int port);

void polld_mux_new(int masterfd, int newfd);
void polld_mux_write(int fd, stream s, char *data, int sz);
void polld_mux_read(int fd);
void polld_mux_parse(int fd, sexy_t packet, char *data);
void polld_mux_error(int fd, stream s);
